/*
 * Copyright (C) 2004-2011
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
package org.kohsuke.rngom.digested;

/**
 * @author Kohsuke Kawaguchi (kk@kohsuke.org)
 */
public interface DPatternVisitor<V> {
    V onAttribute( DAttributePattern p );
    V onChoice( DChoicePattern p );
    V onData( DDataPattern p );
    V onElement( DElementPattern p );
    V onEmpty( DEmptyPattern p );
    V onGrammar( DGrammarPattern p );
    V onGroup( DGroupPattern p );
    V onInterleave( DInterleavePattern p );
    V onList( DListPattern p );
    V onMixed( DMixedPattern p );
    V onNotAllowed( DNotAllowedPattern p );
    V onOneOrMore( DOneOrMorePattern p );
    V onOptional( DOptionalPattern p );
    V onRef( DRefPattern p );
    V onText( DTextPattern p );
    V onValue( DValuePattern p );
    V onZeroOrMore( DZeroOrMorePattern p );
}
