/*
 * Copyright (C) 2004-2011
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
package org.kohsuke.rngom.nc;

import javax.xml.namespace.QName;

/**
 * @author Kohsuke Kawaguchi
 */
public class NameClassWalker implements NameClassVisitor<Void> {

    public Void visitChoice(NameClass nc1, NameClass nc2) {
        nc1.accept(this);
        return nc2.accept(this);
    }

    public Void visitNsName(String ns) {
        return null;
    }

    public Void visitNsNameExcept(String ns, NameClass nc) {
        return nc.accept(this);
    }

    public Void visitAnyName() {
        return null;
    }

    public Void visitAnyNameExcept(NameClass nc) {
        return nc.accept(this);
    }

    public Void visitName(QName name) {
        return null;
    }

    public Void visitNull() {
        return null;
    }
}
